[LeetCode] Number of Ways to Form a Target String Given a Dictionary

1639. Number of Ways to Form a Target String Given a Dictionary

You are given a list of strings of the same length words and a string target.

Your task is to form target using the given words under the following rules:

  • target should be formed from left to right.
  • To form the ith character (0-indexed) of target, you can choose the kth character of the jth string in words if target[i] = words[j][k].
  • Once you use the kth character of the jth string of words, you can no longer use the xth character of any string in words where x <= k. In other words, all characters to the left of or at index k become unusuable for every string.
  • Repeat the process until you form the string target.

Notice that you can use multiple characters from the same string in words provided the conditions above are met.

Return the number of ways to form target from words. Since the answer may be too large, return it modulo 109 + 7.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
class Solution {
vector<vector<int>> counter;
long dp[1001][1001];
int mod = 1e9 + 7;
long helper(string&t, int tp, int p) {
if(t.length() == tp) return 1;
if(counter.size() - p < t.length() - tp) return 0;
if(dp[tp][p] != -1) return dp[tp][p];

dp[tp][p] = helper(t,tp,p+1);
if(counter[p][t[tp]-'a']) {
dp[tp][p] = ((counter[p][t[tp]-'a'] * helper(t,tp+1,p+1) % mod) + dp[tp][p]) % mod;
}
return dp[tp][p];
}
public:
int numWays(vector<string>& words, string target) {
memset(dp,-1,sizeof(dp));
counter = vector<vector<int>>(words[0].length(), vector<int>(26,0));
for(auto& w : words) {
for(int i = 0; i < w.length(); i++) {
counter[i][w[i]-'a']++;
}
}
return helper(target,0,0);
}
};
Author: Song Hayoung
Link: https://songhayoung.github.io/2022/02/28/PS/LeetCode/number-of-ways-to-form-a-target-string-given-a-dictionary/
Copyright Notice: All articles in this blog are licensed under CC BY-NC-SA 4.0 unless stating additionally.